#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

bool cmp(int a, int b)
{
    return a < b;
}

int main()
{
    int n, k;
    int a[500000];

    int obrisani = 0;

    scanf("%d%d", &n, &k);


    for(int i = 0; i < n; i++)
    {
        scanf("%d", &a[i]);

        if(a[i - 1] != -1)
        {
            if(obrisani < k && a[i - 1] > a[i])
            {
                obrisani++;
                //printf("\nObrisi index %d, vrednost %d, obrisani %d\n", i - 1, a[i - 1], obrisani);
                a[i - 1] = -1;

                ///DA LI JE SADA NEKO IZA VECI
                for(int j = i - 2; j >= 0; j--)
                {
                    //printf("\nobrisani %d, k %d, obrisani < k? %d\n", obrisani.size(), k, obrisani < k);
                    if(obrisani < k && a[j] != -1 && a[j] > a[i])
                    {
                        obrisani++;
                        //printf("asd Obrisi index %d, vrednost %d, obrisani %d\n", j, a[j], obrisani);
                        a[j] = -1;
                    }
                    else
                        break;
                }
            }
        }
    }

    if(obrisani < k)
    {
        int i = n - 1;
        while(obrisani != k)
        {
            if(a[i] != -1)
            {
                obrisani++;
                a[i--] = -1;
            }
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(a[i] != -1)
            printf("%d ", a[i]);
    }

    return 0;
}